/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: cam */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.Libitscam_asn1 */
/* Created: Fri Apr 15 16:16:01 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsCam_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-dte/oss20212gen/LibItsCam_asn1.gen DENM.asn CAM.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.*;

/**
 * Define the ASN1 Type DecentralizedSituationManagement from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class DecentralizedSituationManagement extends Sequence {
    
    /**
     * The default constructor.
     */
    public DecentralizedSituationManagement()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public DecentralizedSituationManagement(ActionID actionID, 
		    DataVersion dataVersion, TimeStamp expiryTime, 
		    INTEGER frequency, INTEGER reliability, 
		    BOOLEAN isNegation)
    {
	setActionID(actionID);
	setDataVersion(dataVersion);
	setExpiryTime(expiryTime);
	setFrequency(frequency);
	setReliability(reliability);
	setIsNegation(isNegation);
    }
    
    /**
     * Construct with components.
     */
    public DecentralizedSituationManagement(ActionID actionID, 
		    DataVersion dataVersion, TimeStamp expiryTime, 
		    long frequency, long reliability, boolean isNegation)
    {
	this(actionID, dataVersion, expiryTime, new INTEGER(frequency), 
	     new INTEGER(reliability), new BOOLEAN(isNegation));
    }
    
    /**
     * Construct with required components.
     */
    public DecentralizedSituationManagement(ActionID actionID, 
		    DataVersion dataVersion, long reliability, 
		    boolean isNegation)
    {
	setActionID(actionID);
	setDataVersion(dataVersion);
	setReliability(reliability);
	setIsNegation(isNegation);
    }
    
    public void initComponents()
    {
	mComponents[0] = new ActionID();
	mComponents[1] = new DataVersion();
	mComponents[2] = new TimeStamp();
	mComponents[3] = new INTEGER();
	mComponents[4] = new INTEGER();
	mComponents[5] = new BOOLEAN();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[6];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new ActionID();
	    case 1:
		return new DataVersion();
	    case 2:
		return new TimeStamp();
	    case 3:
		return new INTEGER();
	    case 4:
		return new INTEGER();
	    case 5:
		return new BOOLEAN();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "actionID"
    public ActionID getActionID()
    {
	return (ActionID)mComponents[0];
    }
    
    public void setActionID(ActionID actionID)
    {
	mComponents[0] = actionID;
    }
    
    
    // Methods for field "dataVersion"
    public DataVersion getDataVersion()
    {
	return (DataVersion)mComponents[1];
    }
    
    public void setDataVersion(DataVersion dataVersion)
    {
	mComponents[1] = dataVersion;
    }
    
    
    // Methods for field "expiryTime"
    public TimeStamp getExpiryTime()
    {
	return (TimeStamp)mComponents[2];
    }
    
    public void setExpiryTime(TimeStamp expiryTime)
    {
	mComponents[2] = expiryTime;
    }
    
    public boolean hasExpiryTime()
    {
	return componentIsPresent(2);
    }
    
    public void deleteExpiryTime()
    {
	setComponentAbsent(2);
    }
    
    
    // Methods for field "frequency"
    public long getFrequency()
    {
	return ((INTEGER)mComponents[3]).longValue();
    }
    
    public void setFrequency(long frequency)
    {
	setFrequency(new INTEGER(frequency));
    }
    
    public void setFrequency(INTEGER frequency)
    {
	mComponents[3] = frequency;
    }
    
    public boolean hasFrequency()
    {
	return componentIsPresent(3);
    }
    
    public void deleteFrequency()
    {
	setComponentAbsent(3);
    }
    
    
    // Methods for field "reliability"
    public long getReliability()
    {
	return ((INTEGER)mComponents[4]).longValue();
    }
    
    public void setReliability(long reliability)
    {
	setReliability(new INTEGER(reliability));
    }
    
    public void setReliability(INTEGER reliability)
    {
	mComponents[4] = reliability;
    }
    
    
    // Methods for field "isNegation"
    public boolean getIsNegation()
    {
	return ((BOOLEAN)mComponents[5]).booleanValue();
    }
    
    public void setIsNegation(boolean isNegation)
    {
	setIsNegation(new BOOLEAN(isNegation));
    }
    
    public void setIsNegation(BOOLEAN isNegation)
    {
	mComponents[5] = isNegation;
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
	    "DecentralizedSituationManagement"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "DecentralizedSituationManagement"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"ActionID"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"ActionID"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				    "ActionID"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				    "ActionID"
				)
			    ),
			    0
			)
		    ),
		    "actionID",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"DataVersion"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"DataVersion"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new DataVersion(0), 
				    new DataVersion(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"firstVersion",
					0
				    ),
				    new MemberListElement (
					"secondVersion",
					1
				    ),
				    new MemberListElement (
					"cancellation",
					255
				    )
				}
			    )
			)
		    ),
		    "dataVersion",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsCam_asn1.denm_pdu_descriptions",
				"TimeStamp"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"TimeStamp"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new TimeStamp(0), 
				    new TimeStamp(281474976710655L),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(281474976710655L)
			    ),
			    null
			)
		    ),
		    "expiryTime",
		    2,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"com.oss.asn1",
				"INTEGER"
			    ),
			    new QName (
				"builtin",
				"INTEGER"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new com.oss.asn1.INTEGER(0), 
				    new com.oss.asn1.INTEGER(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    null
			)
		    ),
		    "frequency",
		    3,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8004
				}
			    ),
			    new QName (
				"com.oss.asn1",
				"INTEGER"
			    ),
			    new QName (
				"builtin",
				"INTEGER"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new com.oss.asn1.INTEGER(0), 
				    new com.oss.asn1.INTEGER(100),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(100)
			    ),
			    null
			)
		    ),
		    "reliability",
		    4,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new TypeInfo (
			    new Tags (
				new short[] {
				    (short)0x8005
				}
			    ),
			    new QName (
				"com.oss.asn1",
				"BOOLEAN"
			    ),
			    new QName (
				"builtin",
				"BOOLEAN"
			    ),
			    12314,
			    null
			)
		    ),
		    "isNegation",
		    5,
		    2,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8004, 4)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8005, 5)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' DecentralizedSituationManagement object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' DecentralizedSituationManagement object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for DecentralizedSituationManagement
