/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm-pdu-descriptions */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Tue Jun 28 12:09:14 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -per -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6535gen/LibItsDenm_asn1.gen DENM-PDU-Descriptions.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.*;

/**
 * Define the ASN1 Type DecentralizedSituation from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class DecentralizedSituation extends Sequence {
    
    /**
     * The default constructor.
     */
    public DecentralizedSituation()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public DecentralizedSituation(TrafficFlowEffect trafficFlowEffect, 
		    Situation situation, Situation linkedCause, 
		    Severity severity, _1 eventCharact, 
		    VehicleCommonParameters vehicleCommonParameters, 
		    ProfileParameters profile)
    {
	setTrafficFlowEffect(trafficFlowEffect);
	setSituation(situation);
	setLinkedCause(linkedCause);
	setSeverity(severity);
	setEventCharact(eventCharact);
	setVehicleCommonParameters(vehicleCommonParameters);
	setProfile(profile);
    }
    
    /**
     * Construct with required components.
     */
    public DecentralizedSituation(Situation situation, Severity severity)
    {
	setSituation(situation);
	setSeverity(severity);
    }
    
    public void initComponents()
    {
	mComponents[0] = new TrafficFlowEffect();
	mComponents[1] = new Situation();
	mComponents[2] = new Situation();
	mComponents[3] = Severity.informative;
	mComponents[4] = new _1();
	mComponents[5] = new VehicleCommonParameters();
	mComponents[6] = new ProfileParameters();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[7];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new TrafficFlowEffect();
	    case 1:
		return new Situation();
	    case 2:
		return new Situation();
	    case 3:
		return Severity.informative;
	    case 4:
		return new _1();
	    case 5:
		return new VehicleCommonParameters();
	    case 6:
		return new ProfileParameters();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "trafficFlowEffect"
    public TrafficFlowEffect getTrafficFlowEffect()
    {
	return (TrafficFlowEffect)mComponents[0];
    }
    
    public void setTrafficFlowEffect(TrafficFlowEffect trafficFlowEffect)
    {
	mComponents[0] = trafficFlowEffect;
    }
    
    public boolean hasTrafficFlowEffect()
    {
	return componentIsPresent(0);
    }
    
    public void deleteTrafficFlowEffect()
    {
	setComponentAbsent(0);
    }
    
    
    // Methods for field "situation"
    public Situation getSituation()
    {
	return (Situation)mComponents[1];
    }
    
    public void setSituation(Situation situation)
    {
	mComponents[1] = situation;
    }
    
    
    // Methods for field "linkedCause"
    public Situation getLinkedCause()
    {
	return (Situation)mComponents[2];
    }
    
    public void setLinkedCause(Situation linkedCause)
    {
	mComponents[2] = linkedCause;
    }
    
    public boolean hasLinkedCause()
    {
	return componentIsPresent(2);
    }
    
    public void deleteLinkedCause()
    {
	setComponentAbsent(2);
    }
    
    
    // Methods for field "severity"
    public Severity getSeverity()
    {
	return (Severity)mComponents[3];
    }
    
    public void setSeverity(Severity severity)
    {
	mComponents[3] = severity;
    }
    
    
    // Methods for field "eventCharact"
    public _1 getEventCharact()
    {
	return (_1)mComponents[4];
    }
    
    public void setEventCharact(_1 eventCharact)
    {
	mComponents[4] = eventCharact;
    }
    
    public boolean hasEventCharact()
    {
	return componentIsPresent(4);
    }
    
    public void deleteEventCharact()
    {
	setComponentAbsent(4);
    }
    
    
    
    /**
     * Define the ASN1 Type _1 from ASN1 Module DENM_PDU_Descriptions.
     * @see Sequence
     */
    public static class _1 extends Sequence {
	
	/**
	 * The default constructor.
	 */
	public _1()
	{
	}
	
	/**
	 * Construct with AbstractData components.
	 */
	public _1(BOOLEAN eventmobility, _2 causeType, _3 relevance, 
			BOOLEAN timeCriticality)
	{
	    setEventmobility(eventmobility);
	    setCauseType(causeType);
	    setRelevance(relevance);
	    setTimeCriticality(timeCriticality);
	}
	
	/**
	 * Construct with components.
	 */
	public _1(boolean eventmobility, _2 causeType, _3 relevance, 
			boolean timeCriticality)
	{
	    this(new BOOLEAN(eventmobility), causeType, relevance, 
		 new BOOLEAN(timeCriticality));
	}
	
	public void initComponents()
	{
	    mComponents[0] = new BOOLEAN();
	    mComponents[1] = _2.itsStation;
	    mComponents[2] = _3.physicallyRelevant;
	    mComponents[3] = new BOOLEAN();
	}
	
	// Instance initializer
	{
	    mComponents = new AbstractData[4];
	}
	
	// Method to create a specific component instance
	public AbstractData createInstance(int index)
	{
	    switch (index) {
		case 0:
		    return new BOOLEAN();
		case 1:
		    return _2.itsStation;
		case 2:
		    return _3.physicallyRelevant;
		case 3:
		    return new BOOLEAN();
		default:
		    throw new InternalError("AbstractCollection.createInstance()");
	    }
	    
	}
	
	
	// Methods for field "eventmobility"
	public boolean getEventmobility()
	{
	    return ((BOOLEAN)mComponents[0]).booleanValue();
	}
	
	public void setEventmobility(boolean eventmobility)
	{
	    setEventmobility(new BOOLEAN(eventmobility));
	}
	
	public void setEventmobility(BOOLEAN eventmobility)
	{
	    mComponents[0] = eventmobility;
	}
	
	
	// Methods for field "causeType"
	public _2 getCauseType()
	{
	    return (_2)mComponents[1];
	}
	
	public void setCauseType(_2 causeType)
	{
	    mComponents[1] = causeType;
	}
	
	
	
	/**
	 * Define the ASN1 Type _2 from ASN1 Module DENM_PDU_Descriptions.
	 * @see Enumerated
	 */
	public static final class _2 extends Enumerated {
	    
	    /**
	     * The default constructor.
	     */
	    private _2()
	    {
		super(cFirstNumber);
	    }
	    
	    protected _2(long value)
	    {
		super(value);
	    }
	    
	    // Named list definitions.
	    public static final _2 itsStation =
		new _2(0);
	    public static final _2 geographicalRegion =
		new _2(1);
	    private final static _2 cNamedNumbers[] = {
		 itsStation, 
		 geographicalRegion
	    };
	    protected final static long cFirstNumber = 0;
	    protected final static boolean cLinearNumbers = false;
	    
	    public Enumerated[] getNamedNumbers()
	    {
		return cNamedNumbers;
	    }
	    
	    public boolean hasLinearNumbers()
	    {
		return cLinearNumbers;
	    }
	    
	    public long getFirstNumber()
	    {
		return cFirstNumber;
	    }
	    
	    public static _2 valueOf(long value)
	    {
		return (_2)itsStation.lookupValue(value);
	    }
	    
	    /**
	     * Initialize the type descriptor.
	     */
	    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
		new Tags (
		    new short[] {
			(short)0x8001
		    }
		),
		new QName (
		    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
		    "DecentralizedSituation$_1$_2"
		),
		new QName (
		    "builtin",
		    "ENUMERATED"
		),
		12314,
		null,
		new MemberList (
		    new MemberListElement[] {
			new MemberListElement (
			    "itsStation",
			    0
			),
			new MemberListElement (
			    "geographicalRegion",
			    1
			)
		    }
		),
		0,
		itsStation
	    );
	    
	    /**
	     * Get the type descriptor (TypeInfo) of 'this' _2 object.
	     */
	    public TypeInfo getTypeInfo()
	    {
		return c_typeinfo;
	    }
	    
	    /**
	     * Get the static type descriptor (TypeInfo) of 'this' _2 object.
	     */
	    public static TypeInfo getStaticTypeInfo()
	    {
		return c_typeinfo;
	    }
	    
	} // End class definition for _2

	// Methods for field "relevance"
	public _3 getRelevance()
	{
	    return (_3)mComponents[2];
	}
	
	public void setRelevance(_3 relevance)
	{
	    mComponents[2] = relevance;
	}
	
	
	
	/**
	 * Define the ASN1 Type _3 from ASN1 Module DENM_PDU_Descriptions.
	 * @see Enumerated
	 */
	public static final class _3 extends Enumerated {
	    
	    /**
	     * The default constructor.
	     */
	    private _3()
	    {
		super(cFirstNumber);
	    }
	    
	    protected _3(long value)
	    {
		super(value);
	    }
	    
	    // Named list definitions.
	    public static final _3 physicallyRelevant =
		new _3(0);
	    public static final _3 difficultDrivingConditions =
		new _3(1);
	    private final static _3 cNamedNumbers[] = {
		 physicallyRelevant, 
		 difficultDrivingConditions
	    };
	    protected final static long cFirstNumber = 0;
	    protected final static boolean cLinearNumbers = false;
	    
	    public Enumerated[] getNamedNumbers()
	    {
		return cNamedNumbers;
	    }
	    
	    public boolean hasLinearNumbers()
	    {
		return cLinearNumbers;
	    }
	    
	    public long getFirstNumber()
	    {
		return cFirstNumber;
	    }
	    
	    public static _3 valueOf(long value)
	    {
		return (_3)physicallyRelevant.lookupValue(value);
	    }
	    
	    /**
	     * Initialize the type descriptor.
	     */
	    private static final EnumeratedInfo c_typeinfo = new EnumeratedInfo (
		new Tags (
		    new short[] {
			(short)0x8002
		    }
		),
		new QName (
		    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
		    "DecentralizedSituation$_1$_3"
		),
		new QName (
		    "builtin",
		    "ENUMERATED"
		),
		12314,
		null,
		new MemberList (
		    new MemberListElement[] {
			new MemberListElement (
			    "physicallyRelevant",
			    0
			),
			new MemberListElement (
			    "difficultDrivingConditions",
			    1
			)
		    }
		),
		0,
		physicallyRelevant
	    );
	    
	    /**
	     * Get the type descriptor (TypeInfo) of 'this' _3 object.
	     */
	    public TypeInfo getTypeInfo()
	    {
		return c_typeinfo;
	    }
	    
	    /**
	     * Get the static type descriptor (TypeInfo) of 'this' _3 object.
	     */
	    public static TypeInfo getStaticTypeInfo()
	    {
		return c_typeinfo;
	    }
	    
	} // End class definition for _3

	// Methods for field "timeCriticality"
	public boolean getTimeCriticality()
	{
	    return ((BOOLEAN)mComponents[3]).booleanValue();
	}
	
	public void setTimeCriticality(boolean timeCriticality)
	{
	    setTimeCriticality(new BOOLEAN(timeCriticality));
	}
	
	public void setTimeCriticality(BOOLEAN timeCriticality)
	{
	    mComponents[3] = timeCriticality;
	}
	
	
	/**
	 * Initialize the type descriptor.
	 */
	private static final SequenceInfo c_typeinfo = new SequenceInfo (
	    new Tags (
		new short[] {
		    (short)0x8004
		}
	    ),
	    new QName (
		"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
		"DecentralizedSituation$_1"
	    ),
	    new QName (
		"builtin",
		"SEQUENCE"
	    ),
	    12318,
	    null,
	    new Fields (
		new SequenceFieldInfo[] {
		    new SequenceFieldInfo (
			new TypeInfoRef (
			    new TypeInfo (
				new Tags (
				    new short[] {
					(short)0x8000
				    }
				),
				new QName (
				    "com.oss.asn1",
				    "BOOLEAN"
				),
				new QName (
				    "builtin",
				    "BOOLEAN"
				),
				12314,
				null
			    )
			),
			"eventmobility",
			0,
			2,
			null
		    ),
		    new SequenceFieldInfo (
			new TypeInfoRef (
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"DecentralizedSituation$_1$_2"
			    )
			),
			"causeType",
			1,
			2,
			null
		    ),
		    new SequenceFieldInfo (
			new TypeInfoRef (
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"DecentralizedSituation$_1$_3"
			    )
			),
			"relevance",
			2,
			2,
			null
		    ),
		    new SequenceFieldInfo (
			new TypeInfoRef (
			    new TypeInfo (
				new Tags (
				    new short[] {
					(short)0x8003
				    }
				),
				new QName (
				    "com.oss.asn1",
				    "BOOLEAN"
				),
				new QName (
				    "builtin",
				    "BOOLEAN"
				),
				12314,
				null
			    )
			),
			"timeCriticality",
			3,
			2,
			null
		    )
		}
	    ),
	    0,
	    new TagDecoders (
		new TagDecoder[] {
		    new TagDecoder (
			new TagDecoderElement[] {
			    new TagDecoderElement((short)0x8000, 0)
			}
		    ),
		    new TagDecoder (
			new TagDecoderElement[] {
			    new TagDecoderElement((short)0x8001, 1)
			}
		    ),
		    new TagDecoder (
			new TagDecoderElement[] {
			    new TagDecoderElement((short)0x8002, 2)
			}
		    ),
		    new TagDecoder (
			new TagDecoderElement[] {
			    new TagDecoderElement((short)0x8003, 3)
			}
		    )
		}
	    ),
	    0
	);
	
	/**
	 * Get the type descriptor (TypeInfo) of 'this' _1 object.
	 */
	public TypeInfo getTypeInfo()
	{
	    return c_typeinfo;
	}
	
	/**
	 * Get the static type descriptor (TypeInfo) of 'this' _1 object.
	 */
	public static TypeInfo getStaticTypeInfo()
	{
	    return c_typeinfo;
	}
	
    } // End class definition for _1

    // Methods for field "vehicleCommonParameters"
    public VehicleCommonParameters getVehicleCommonParameters()
    {
	return (VehicleCommonParameters)mComponents[5];
    }
    
    public void setVehicleCommonParameters(VehicleCommonParameters vehicleCommonParameters)
    {
	mComponents[5] = vehicleCommonParameters;
    }
    
    public boolean hasVehicleCommonParameters()
    {
	return componentIsPresent(5);
    }
    
    public void deleteVehicleCommonParameters()
    {
	setComponentAbsent(5);
    }
    
    
    // Methods for field "profile"
    public ProfileParameters getProfile()
    {
	return (ProfileParameters)mComponents[6];
    }
    
    public void setProfile(ProfileParameters profile)
    {
	mComponents[6] = profile;
    }
    
    public boolean hasProfile()
    {
	return componentIsPresent(6);
    }
    
    public void deleteProfile()
    {
	setComponentAbsent(6);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "DecentralizedSituation"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "DecentralizedSituation"
	),
	12314,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"TrafficFlowEffect"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"TrafficFlowEffect"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new TrafficFlowEffect(0), 
				    new TrafficFlowEffect(7),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(7)
			    ),
			    null
			)
		    ),
		    "trafficFlowEffect",
		    0,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Situation"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Situation"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Situation"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Situation"
				)
			    ),
			    0
			)
		    ),
		    "situation",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Situation"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Situation"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Situation"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Situation"
				)
			    ),
			    0
			)
		    ),
		    "linkedCause",
		    2,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Severity"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Severity"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"informative",
					1
				    ),
				    new MemberListElement (
					"obstacles",
					2
				    ),
				    new MemberListElement (
					"danger",
					3
				    ),
				    new MemberListElement (
					"highestDanger",
					4
				    )
				}
			    ),
			    0,
			    Severity.informative
			)
		    ),
		    "severity",
		    3,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new QName (
			    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
			    "DecentralizedSituation$_1"
			)
		    ),
		    "eventCharact",
		    4,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8005
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"VehicleCommonParameters"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"VehicleCommonParameters"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "VehicleCommonParameters"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "VehicleCommonParameters"
				)
			    ),
			    0
			)
		    ),
		    "vehicleCommonParameters",
		    5,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ChoiceInfo (
			    new Tags (
				new short[] {
				    (short)0x8006
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"ProfileParameters"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"ProfileParameters"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "ProfileParameters"
				)
			    ),
			    0,
			    new TagDecoder (
				new TagDecoderElement[] {
				    new TagDecoderElement((short)0x8000, 0),
				    new TagDecoderElement((short)0x8001, 1),
				    new TagDecoderElement((short)0x8002, 2)
				}
			    )
			)
		    ),
		    "profile",
		    6,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0),
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2),
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8006, 6)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' DecentralizedSituation object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' DecentralizedSituation object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for DecentralizedSituation
