/*************************************************************/
/* Copyright (C) 2011 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: denm-pdu-descriptions */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.Libitsdenm_asn1 */
/* Created: Tue Jun 28 12:09:14 2011 */
/* ASN.1 Compiler for Java version: 4.0 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1 -nolistingfile
 * -nomodlistingfile -shortennames -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -per -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-apache/oss6535gen/LibItsDenm_asn1.gen DENM-PDU-Descriptions.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions;

import com.oss.asn1.*;
import com.oss.metadata.*;
import org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.*;

/**
 * Define the ASN1 Type RelevanceArea from ASN1 Module DENM_PDU_Descriptions.
 * @see Sequence
 */

public class RelevanceArea extends Sequence {
    
    /**
     * The default constructor.
     */
    public RelevanceArea()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public RelevanceArea(Latitude geoAreaCenterLatitude, 
		    Longitude geoAreaCenterLongitude, _6 shape, 
		    DirectionalityFilter directionalityFilter, 
		    RelativeSize disseminationAreaSize)
    {
	setGeoAreaCenterLatitude(geoAreaCenterLatitude);
	setGeoAreaCenterLongitude(geoAreaCenterLongitude);
	setShape(shape);
	setDirectionalityFilter(directionalityFilter);
	setDisseminationAreaSize(disseminationAreaSize);
    }
    
    /**
     * Construct with required components.
     */
    public RelevanceArea(Latitude geoAreaCenterLatitude, 
		    Longitude geoAreaCenterLongitude, _6 shape)
    {
	setGeoAreaCenterLatitude(geoAreaCenterLatitude);
	setGeoAreaCenterLongitude(geoAreaCenterLongitude);
	setShape(shape);
    }
    
    public void initComponents()
    {
	mComponents[0] = new Latitude();
	mComponents[1] = new Longitude();
	mComponents[2] = new _6();
	mComponents[3] = DirectionalityFilter.noFilter;
	mComponents[4] = RelativeSize.same;
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[5];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new Latitude();
	    case 1:
		return new Longitude();
	    case 2:
		return new _6();
	    case 3:
		return DirectionalityFilter.noFilter;
	    case 4:
		return RelativeSize.same;
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    // Default Values
    public static final RelativeSize disseminationAreaSize__default = 
	RelativeSize.same;
    
    // Methods for field "geoAreaCenterLatitude"
    public Latitude getGeoAreaCenterLatitude()
    {
	return (Latitude)mComponents[0];
    }
    
    public void setGeoAreaCenterLatitude(Latitude geoAreaCenterLatitude)
    {
	mComponents[0] = geoAreaCenterLatitude;
    }
    
    
    // Methods for field "geoAreaCenterLongitude"
    public Longitude getGeoAreaCenterLongitude()
    {
	return (Longitude)mComponents[1];
    }
    
    public void setGeoAreaCenterLongitude(Longitude geoAreaCenterLongitude)
    {
	mComponents[1] = geoAreaCenterLongitude;
    }
    
    
    // Methods for field "shape"
    public _6 getShape()
    {
	return (_6)mComponents[2];
    }
    
    public void setShape(_6 shape)
    {
	mComponents[2] = shape;
    }
    
    
    
    /**
     * Define the ASN1 Type _6 from ASN1 Module DENM_PDU_Descriptions.
     * @see Choice
     */
    public static class _6 extends Choice {
	
	/**
	 * The default constructor.
	 */
	public _6()
	{
	}
	
	public static final  int  circle_chosen = 1;
	public static final  int  rectangle_chosen = 2;
	public static final  int  ellipse_chosen = 3;
	
	// Methods for field "circle"
	public static _6 create_6WithCircle(Circle circle)
	{
	    _6 __object = new _6();

	    __object.setCircle(circle);
	    return __object;
	}
	
	public boolean hasCircle()
	{
	    return getChosenFlag() == circle_chosen;
	}
	
	public void setCircle(Circle circle)
	{
	    setChosenValue(circle);
	    setChosenFlag(circle_chosen);
	}
	
	
	// Methods for field "rectangle"
	public static _6 create_6WithRectangle(Rectangle rectangle)
	{
	    _6 __object = new _6();

	    __object.setRectangle(rectangle);
	    return __object;
	}
	
	public boolean hasRectangle()
	{
	    return getChosenFlag() == rectangle_chosen;
	}
	
	public void setRectangle(Rectangle rectangle)
	{
	    setChosenValue(rectangle);
	    setChosenFlag(rectangle_chosen);
	}
	
	
	// Methods for field "ellipse"
	public static _6 create_6WithEllipse(Ellipse ellipse)
	{
	    _6 __object = new _6();

	    __object.setEllipse(ellipse);
	    return __object;
	}
	
	public boolean hasEllipse()
	{
	    return getChosenFlag() == ellipse_chosen;
	}
	
	public void setEllipse(Ellipse ellipse)
	{
	    setChosenValue(ellipse);
	    setChosenFlag(ellipse_chosen);
	}
	
	
	// Method to create a specific choice instance
	public AbstractData createInstance(int chosen)
	{
	    switch (chosen) {
		case circle_chosen:
		    return new Circle();
		case rectangle_chosen:
		    return new Rectangle();
		case ellipse_chosen:
		    return new Ellipse();
		default:
		    throw new InternalError("Choice.createInstance()");
	    }
	    
	}
	
	/**
	 * Initialize the type descriptor.
	 */
	private static final ChoiceInfo c_typeinfo = new ChoiceInfo (
	    new Tags (
		new short[] {
		    (short)0x8002
		}
	    ),
	    new QName (
		"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
		"RelevanceArea$_6"
	    ),
	    new QName (
		"builtin",
		"CHOICE"
	    ),
	    12314,
	    null,
	    new Fields (
		new FieldInfo[] {
		    new FieldInfo (
			new TypeInfoRef (
			    new SequenceInfo (
				new Tags (
				    new short[] {
					(short)0x8000
				    }
				),
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Circle"
				),
				new QName (
				    "DENM-PDU-Descriptions",
				    "Circle"
				),
				12314,
				null,
				new FieldsRef (
				    new QName (
					"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
					"Circle"
				    )
				),
				0,
				new TagDecodersRef (
				    new QName (
					"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
					"Circle"
				    )
				),
				0
			    )
			),
			"circle",
			0,
			2
		    ),
		    new FieldInfo (
			new TypeInfoRef (
			    new SequenceInfo (
				new Tags (
				    new short[] {
					(short)0x8001
				    }
				),
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Rectangle"
				),
				new QName (
				    "DENM-PDU-Descriptions",
				    "Rectangle"
				),
				12314,
				null,
				new FieldsRef (
				    new QName (
					"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
					"Rectangle"
				    )
				),
				0,
				new TagDecodersRef (
				    new QName (
					"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
					"Rectangle"
				    )
				),
				0
			    )
			),
			"rectangle",
			1,
			2
		    ),
		    new FieldInfo (
			new TypeInfoRef (
			    new SequenceInfo (
				new Tags (
				    new short[] {
					(short)0x8002
				    }
				),
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Ellipse"
				),
				new QName (
				    "DENM-PDU-Descriptions",
				    "Ellipse"
				),
				12314,
				null,
				new FieldsRef (
				    new QName (
					"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
					"Ellipse"
				    )
				),
				0,
				new TagDecodersRef (
				    new QName (
					"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
					"Ellipse"
				    )
				),
				0
			    )
			),
			"ellipse",
			2,
			2
		    )
		}
	    ),
	    0,
	    new TagDecoder (
		new TagDecoderElement[] {
		    new TagDecoderElement((short)0x8000, 0),
		    new TagDecoderElement((short)0x8001, 1),
		    new TagDecoderElement((short)0x8002, 2)
		}
	    )
	);
	
	/**
	 * Get the type descriptor (TypeInfo) of 'this' _6 object.
	 */
	public TypeInfo getTypeInfo()
	{
	    return c_typeinfo;
	}
	
	/**
	 * Get the static type descriptor (TypeInfo) of 'this' _6 object.
	 */
	public static TypeInfo getStaticTypeInfo()
	{
	    return c_typeinfo;
	}
	
    } // End class definition for _6

    // Methods for field "directionalityFilter"
    public DirectionalityFilter getDirectionalityFilter()
    {
	return (DirectionalityFilter)mComponents[3];
    }
    
    public void setDirectionalityFilter(DirectionalityFilter directionalityFilter)
    {
	mComponents[3] = directionalityFilter;
    }
    
    public boolean hasDirectionalityFilter()
    {
	return componentIsPresent(3);
    }
    
    public void deleteDirectionalityFilter()
    {
	setComponentAbsent(3);
    }
    
    
    // Methods for field "disseminationAreaSize"
    public RelativeSize getDisseminationAreaSize()
    {
	if (hasDisseminationAreaSize())
	    return (RelativeSize)mComponents[4];
	else
	    return (RelativeSize)disseminationAreaSize__default.clone();
    }
    
    public void setDisseminationAreaSize(RelativeSize disseminationAreaSize)
    {
	mComponents[4] = disseminationAreaSize;
    }
    
    public void setDisseminationAreaSizeToDefault()
    {
	setDisseminationAreaSize(disseminationAreaSize__default);
    }
    
    public boolean hasDefaultDisseminationAreaSize()
    {
	return true;
    }
    
    public boolean hasDisseminationAreaSize()
    {
	return componentIsPresent(4);
    }
    
    public void deleteDisseminationAreaSize()
    {
	setComponentAbsent(4);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
	    "RelevanceArea"
	),
	new QName (
	    "DENM-PDU-Descriptions",
	    "RelevanceArea"
	),
	12318,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Latitude"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Latitude"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Latitude"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Latitude"
				)
			    ),
			    0
			)
		    ),
		    "geoAreaCenterLatitude",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"Longitude"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"Longitude"
			    ),
			    12314,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Longitude"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				    "Longitude"
				)
			    ),
			    0
			)
		    ),
		    "geoAreaCenterLongitude",
		    1,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new QName (
			    "org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
			    "RelevanceArea$_6"
			)
		    ),
		    "shape",
		    2,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"DirectionalityFilter"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"DirectionalityFilter"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"noFilter",
					0
				    ),
				    new MemberListElement (
					"approachingCenter",
					1
				    ),
				    new MemberListElement (
					"leavingCenter",
					2
				    )
				}
			    ),
			    0,
			    DirectionalityFilter.noFilter
			)
		    ),
		    "directionalityFilter",
		    3,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8004
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsDenm_asn1.denm_pdu_descriptions",
				"RelativeSize"
			    ),
			    new QName (
				"DENM-PDU-Descriptions",
				"RelativeSize"
			    ),
			    12314,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"same",
					0
				    ),
				    new MemberListElement (
					"oneAndHalfSize",
					1
				    ),
				    new MemberListElement (
					"doubleSize",
					2
				    ),
				    new MemberListElement (
					"tripleSize",
					3
				    )
				}
			    ),
			    0,
			    RelativeSize.same
			)
		    ),
		    "disseminationAreaSize",
		    4,
		    3,
		    disseminationAreaSize__default
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8004, 4)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' RelevanceArea object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' RelevanceArea object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for RelevanceArea
